// dll1.cpp : Defines the entry point for the DLL application.
//
typedef struct
{
	int nev;	// number of elements
	int nn1;	// dimension of element array
	int npv;	// number of nodes
	int **nel;	// elements nel[nev+1][nn1]: nel[0] not used, single array for all elements
	float (*pkt)[3];	// node coordinates pkt[npv+1][3]: pkt[0] not used
} festruct;

extern "C"
void funct1(void *pWnd,festruct *p1,festruct *p2,int kzfree,int kzf,void *p)
{
	if(kzf != 0) return;  // wrong function type
	if(kzfree) // free allocated memory
	{
		delete [] p2->nel[0];
		delete [] p2->nel;
		delete [] p2->pkt;
		return;
	}

	float z = 5.f;

	int k,nev = p1->nev;
	int npv = p1->npv;
	int **nel = p1->nel;
	int nn1 = p1->nn1;
	float (*pkt)[3] = p1->pkt;

	if(!nev || !nn1 || !npv) return;

	p2->nev = nev;
	p2->npv = npv;
	p2->nn1 = nn1;
	p2->nel = (int **) new char[(nev+1)*sizeof(int *)];
	p2->nel[0] = new int[nn1*(nev+1)*sizeof(int)];

	for(k=1;k<=nev;k++) p2->nel[k] = p2->nel[k-1] + nn1;
	p2->pkt = new float[npv+1][3];

	memcpy(p2->nel[0],p1->nel[0],nn1*(nev+1)*sizeof(int));
	memcpy(p2->pkt,p1->pkt,3*(npv+1)*sizeof(float));

	for(k=1;k<=npv;k++) p2->pkt[k][2] += z;   // translation
	for(k=1;k<=nev;k++) p2->nel[k][3] = 1000; // group ID

	return ;
}