#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "interface.h"
#include "nastran.h"

int main(int argc,char *argv[])
{
	char project[256],fout[256];
	int rtw;
	int geom = 0;
	int mfile = 0;
	int global = 0;

	StructData *structdata = new StructData;

	if(argc > 1)
	{
		sprintf(project,"%s",argv[1]);
	} else
	{
		printf("filetitel of the project ? \n");
		scanf("%s",project);
	}

	if(strlen(project) < 2) goto error;

	// load data from file
	rtw =  getStructData(project,structdata,global);
	if(rtw) goto error;

	// create NASTRAN-file
	if(argc > 2)
	{
		sprintf(fout,"%s",argv[2]);
	} else
	{
		printf("\nfiletitel NASTRAN-file ? \n");
		scanf("%s",fout);
	}
	if(strlen(fout) < 2) goto error;

	// write NASTRAN File
	rtw =  nastran(fout,structdata,project,geom,mfile,1);

	// free memory
	freeStructData(structdata);

	printf("\nNASTRAN file written: %s\n\n",fout);

	printf("exit with input of any integer k = ? ");
	scanf("%d",&rtw);
	
	return 0;

error:
	printf("\n***No NASTRAN file written\n");
	printf("exit with input of any integer k = ? ");
	scanf("%d",&rtw);
	return 1;
}
